import json

from imecilabt.gpulab.util.urn_util import URN

from imecilabt.gpulab.util.proxy_config import ProxyConfig


def test_proxy_config1():
    yml_in = """proxy_username_prefix:
   wall2.ilabt.iminds.be: ''
   ilabt.imec.be: 'fff'
"""

    proxy_config = ProxyConfig()
    proxy_config.load_from_ymlstr(yml_in)

    assert proxy_config.find_proxy_username('urn:publicid:IDN+wall2.ilabt.iminds.be+user+ftester') == 'ftester'
    assert proxy_config.find_proxy_username('urn:publicid:IDN+ilabt.imec.be+user+ftester') == 'fffftester'
    assert proxy_config.find_proxy_username('urn:publicid:IDN+example.com+user+ftester') is None


def test_proxy_config2():
    yml_in = """proxy_username_prefix:
   wall2.ilabt.iminds.be: ''
   ilabt.imec.be: 'blah-'
"""

    proxy_config = ProxyConfig()
    proxy_config.load_from_ymlstr(yml_in)

    assert proxy_config.find_proxy_username(URN(urn='urn:publicid:IDN+wall2.ilabt.iminds.be+user+blih')) == 'blih'
    assert proxy_config.find_proxy_username(URN(urn='urn:publicid:IDN+ilabt.imec.be+user+blih')) == 'blah-blih'
    assert proxy_config.find_proxy_username(URN(urn='urn:publicid:IDN+example.com+user+blih')) is None
